/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Contents of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log


Revision 235 - (show annotations)
Tue Jan 25 14:40:42 2011 UTC (13 years, 2 months ago) by dpavlin
File MIME type: application/x-sh
File size: 5530 byte(s)
use only first ip address
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides: lxc-watchdog
4 # Required-Start: $remote_fs $named $network $time
5 # Required-Stop: $remote_fs $named $network
6 # Required-Start:
7 # Required-Stop:
8 # Default-Start: 2 3 4 5
9 # Default-Stop: 0 1 6
10 # Short-Description: Manage Linux Containers startup/shutdown
11 # Description: Uses clever inotify hack to monitor container's
12 # halt/reboot events watching /var/run/utmp
13 ### END INIT INFO
14
15 # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16 #
17 # based on Tony Risinger post to lxc-users mailing list
18 # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19 #
20 # Install with:
21 # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22 # update-rc.d lxc-watchdog defaults
23
24
25 which inotifywait >/dev/null || apt-get install inotify-tools
26
27
28 lxc_exists() {
29 name=$1
30
31 if [ ! -e /var/lib/lxc/$name/config ] ; then
32 echo "Usage: $0 name"
33 lxc_status
34 exit 1
35 fi
36 }
37
38
39 lxc_rootfs() {
40 grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41 }
42
43 lxc_hostname() {
44 inside=`cat $(lxc_rootfs $1)/etc/hostname`
45 config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46 echo "$config [$inside]";
47 }
48
49 lxc_ip() {
50 ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51 grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52 head -1 | \
53 sed -e 's/ *//g' -e 's/\/.*$//'
54 }
55
56 lxc_status() {
57 ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
58 boot="-"
59 test -s /var/lib/lxc/$name/on_boot && boot="boot"
60 echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
61 done ) | column -t
62 }
63
64
65 cleanup_init_scripts() {
66 rootfs=$(lxc_rootfs $1)
67
68 ls \
69 $rootfs/etc/rc?.d/*checkroot* \
70 $rootfs/etc/rc?.d/*umountfs \
71 $rootfs/etc/rc?.d/*umountroot \
72 $rootfs/etc/rc?.d/*hwclock* \
73 $rootfs/etc/rc?.d/*udev* \
74 2>/dev/null | xargs -i rm -v {}
75
76 echo $1 > $rootfs/etc/hostname
77 grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
78 }
79
80
81 setup_inittab() {
82 rootfs=$(lxc_rootfs $1)
83 remove=$2
84 add=$3
85
86 # let container respond to kill -SIGPWR
87 inittab=$rootfs/etc/inittab
88 if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
89 grep -v "$remove" ${inittab} > ${inittab}.new
90 echo $add >> ${inittab}.new
91 mv ${inittab}.new ${inittab}
92 echo "$inittab modified with $add"
93 fi
94 }
95
96
97 lxc_log() {
98 echo `date +%Y-%m-%dT%H:%M:%S` $*
99 }
100
101
102 lxc_kill() {
103 name=$1
104 sig=$2
105
106 init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
107 if [ -z "$init_pid" ] ; then
108 lxc-info -n $name
109 exit 1
110 fi
111 lxc_log "$name kill $sig $init_pid"
112 /bin/kill $sig $init_pid
113 }
114
115 lxc_stop() {
116 lxc_log "$name stop"
117 lxc_kill $name -SIGPWR
118 lxc-wait -n $name -s STOPPED
119 lxc_log "$name stoped"
120 # rm -f /var/lib/lxc/${name}/on_boot
121 }
122
123
124 lxc_start() {
125 name=$1
126 rootfs=$(lxc_rootfs $1)
127
128 if [ ! -e $rootfs ] ; then
129 echo "ERROR $name rootfs $rootfs not found"
130 return
131 fi
132
133 if ! lxc-info -n $name | grep RUNNING ; then
134 lxc_log "$name start"
135 lxc-start -n $name -o /tmp/${name}.log -d
136 lxc-wait -n $name -s RUNNING
137 lxc-info -n $name
138 test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
139 fi
140 }
141
142 lxc_watchdog() {
143 name=$1
144 rootfs=$(lxc_rootfs $1)
145
146 while true; do
147 vps_utmp=${rootfs}/var/run/utmp
148 tasks=`wc -l < /cgroup/${name}/tasks`
149 test -z "$tasks" && exit 1
150 if [ "$tasks" -eq 1 ]; then
151
152 runlevel="$(runlevel ${vps_utmp})"
153 lxc_log "$name runlevel $runlevel"
154
155 case $runlevel in
156 N*)
157 # nothing for new boot state
158 ;;
159 ??0)
160 lxc_log "$name halt"
161 lxc-stop -n "${name}"
162 lxc-wait -n ${name} -s STOPPED
163 break
164 ;;
165 ??6)
166 lxc_log "$name reboot";
167 lxc-stop -n ${name}
168 lxc-wait -n ${name} -s STOPPED
169 lxc-start -d -n ${name} -o /tmp/${name}.log
170 ;;
171 *)
172 # make sure vps is still running
173 state="$(lxc-info -n "${name}" | sed -e 's/.* is //')"
174 [ "$state" = "RUNNING" ] || break
175 ;;
176 esac
177 else
178 lxc_log "$name $tasks tasks"
179 fi
180
181 # time of 5 minutes on it JUST IN CASE...
182 inotifywait -qqt 300 ${vps_utmp}
183 done
184
185 lxc_log "$name watchdog exited"
186
187 }
188
189
190 usage() {
191 echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
192 exit 3
193 }
194
195 command_on_lxc() {
196 command=$1
197 shift
198
199 echo "# $command $1"
200
201 case "$command" in
202
203 start)
204 lxc_exists $1
205 cleanup_init_scripts $1
206 setup_inittab $1 ":respawn:/sbin/getty.*tty1" "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
207 setup_inittab $1 "::power" "p0::powerfail:/sbin/init 0"
208 setup_inittab $1 "::ctrlaltdel" "p6::ctrlaltdel:/sbin/init 6"
209 lxc_start $1
210 # give container 5 seconds to start more than one process
211 ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
212 ;;
213 stop|halt)
214 lxc_exists $1
215 lxc_stop $1
216 ;;
217 reload|force-reload|restart|reboot)
218 lxc_kill $1 -SIGINT
219 ;;
220 watchdog)
221 lxc_watchdog $1
222 ;;
223 boot)
224 echo $1 > /var/lib/lxc/$1/on_boot
225 ;;
226 disable)
227 echo -n > /var/lib/lxc/$1/on_boot
228 ;;
229 *)
230 usage
231 ;;
232
233 esac
234
235 }
236
237 command=$1
238 test -z "$command" && usage
239 test "$command" = "status" && lxc_status && exit
240 shift
241
242 if [ -z "$1" ] ; then
243 ls /var/lib/lxc/*/on_boot | while read path ; do
244 name=`echo $path | cut -d/ -f5`
245 if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
246 command_on_lxc $command $name
247 else
248 echo "# skip $command $name"
249 fi
250 done
251 else
252 while [ ! -z "$1" ] ; do
253 command_on_lxc $command $1
254 shift
255 done
256 fi
257

Properties

Name Value
svn:executable *

  ViewVC Help
Powered by ViewVC 1.1.26